module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/
/******/
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(Object.prototype.hasOwnProperty.call(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 	};
/******/
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		0: 0
/******/ 	};
/******/
/******/
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "webclient-vue-cesium.common." + ({}[chunkId]||chunkId) + ".js"
/******/ 	}
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/ 	// This file contains only the entry chunk.
/******/ 	// The chunk loading function for additional chunks
/******/ 	__webpack_require__.e = function requireEnsure(chunkId) {
/******/ 		var promises = [];
/******/
/******/
/******/ 		// JSONP chunk loading for javascript
/******/
/******/ 		var installedChunkData = installedChunks[chunkId];
/******/ 		if(installedChunkData !== 0) { // 0 means "already installed".
/******/
/******/ 			// a Promise means "currently loading".
/******/ 			if(installedChunkData) {
/******/ 				promises.push(installedChunkData[2]);
/******/ 			} else {
/******/ 				// setup Promise in chunk cache
/******/ 				var promise = new Promise(function(resolve, reject) {
/******/ 					installedChunkData = installedChunks[chunkId] = [resolve, reject];
/******/ 				});
/******/ 				promises.push(installedChunkData[2] = promise);
/******/
/******/ 				// start chunk loading
/******/ 				var script = document.createElement('script');
/******/ 				var onScriptComplete;
/******/
/******/ 				script.charset = 'utf-8';
/******/ 				script.timeout = 120;
/******/ 				if (__webpack_require__.nc) {
/******/ 					script.setAttribute("nonce", __webpack_require__.nc);
/******/ 				}
/******/ 				script.src = jsonpScriptSrc(chunkId);
/******/
/******/ 				// create error before stack unwound to get useful stacktrace later
/******/ 				var error = new Error();
/******/ 				onScriptComplete = function (event) {
/******/ 					// avoid mem leaks in IE.
/******/ 					script.onerror = script.onload = null;
/******/ 					clearTimeout(timeout);
/******/ 					var chunk = installedChunks[chunkId];
/******/ 					if(chunk !== 0) {
/******/ 						if(chunk) {
/******/ 							var errorType = event && (event.type === 'load' ? 'missing' : event.type);
/******/ 							var realSrc = event && event.target && event.target.src;
/******/ 							error.message = 'Loading chunk ' + chunkId + ' failed.\n(' + errorType + ': ' + realSrc + ')';
/******/ 							error.name = 'ChunkLoadError';
/******/ 							error.type = errorType;
/******/ 							error.request = realSrc;
/******/ 							chunk[1](error);
/******/ 						}
/******/ 						installedChunks[chunkId] = undefined;
/******/ 					}
/******/ 				};
/******/ 				var timeout = setTimeout(function(){
/******/ 					onScriptComplete({ type: 'timeout', target: script });
/******/ 				}, 120000);
/******/ 				script.onerror = script.onload = onScriptComplete;
/******/ 				document.head.appendChild(script);
/******/ 			}
/******/ 		}
/******/ 		return Promise.all(promises);
/******/ 	};
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// on error function for async loading
/******/ 	__webpack_require__.oe = function(err) { console.error(err); throw err; };
/******/
/******/ 	var jsonpArray = (typeof self !== 'undefined' ? self : this)["webpackJsonpwebclient_vue_cesium"] = (typeof self !== 'undefined' ? self : this)["webpackJsonpwebclient_vue_cesium"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "fb15");
/******/ })
/************************************************************************/
/******/ ({

/***/ "2780":
/***/ (function(module, exports, __webpack_require__) {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ "5680":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_WebGlobe_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("2780");
/* harmony import */ var _node_modules_mini_css_extract_plugin_dist_loader_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_WebGlobe_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_mini_css_extract_plugin_dist_loader_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_WebGlobe_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0__);
/* unused harmony reexport * */
 /* unused harmony default export */ var _unused_webpack_default_export = (_node_modules_mini_css_extract_plugin_dist_loader_js_ref_6_oneOf_1_0_node_modules_css_loader_index_js_ref_6_oneOf_1_1_node_modules_vue_loader_lib_loaders_stylePostLoader_js_node_modules_postcss_loader_src_index_js_ref_6_oneOf_1_2_node_modules_cache_loader_dist_cjs_js_ref_0_0_node_modules_vue_loader_lib_index_js_vue_loader_options_WebGlobe_vue_vue_type_style_index_0_lang_css___WEBPACK_IMPORTED_MODULE_0___default.a); 

/***/ }),

/***/ "64c2":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony default export */ __webpack_exports__["a"] = ({
  container: {
    type: [String, HTMLElement],
    default() {
      return `cesium-${("" + Math.random()).split(".")[1]}`;
    }
  },
  /**
   * @description 初始视图模式默认为三维球视图 '2D'表示二维视图 'COLUMBUS_VIEW' 表示三维平面视图
   */
  viewerMode: {
    type: String,
    default: "3D"
  },
  /**
   * @description 是否显示默认的属性信息框
   */
  showInfo: {
    type: Boolean,
    default: false
  },
  /**
   * @description 默认动画控制不显示
   */
  animation: {
    type: Boolean,
    default: true
  },
  /**
   * @description If set to false, the BaseLayerPicker widget will not be created.
   */
  baseLayerPicker: {
    type: Boolean,
    default: true
  },
  /**
   * @description If set to false, the FullscreenButton widget will not be created.
   */
  fullscreenButton: {
    type: Boolean,
    default: true
  },
  /**
   * @description If set to true, the VRButton widget will be created.
   */
  vrButton: {
    type: Boolean,
    default: false
  },

  cameraView: {
    type: Object,
    default: function() {
      return {
        destination: {
          x: -5087907.392038159,
          y: 14207074.175879652,
          z: 3655215.2541255946
        },
        orientation: {
          heading: 6.1827568973283045,
          pitch: -1.2409374391413084,
          roll: 0.0003114284469649675
        }
      };
    }
  }
});


/***/ }),

/***/ "a47c":
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/*!
 * merge-descriptors
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2015 Douglas Christopher Wilson
 * MIT Licensed
 */



/**
 * Module exports.
 * @public
 */

module.exports = merge

/**
 * Module variables.
 * @private
 */

var hasOwnProperty = Object.prototype.hasOwnProperty

/**
 * Merge the property descriptors of `src` into `dest`
 *
 * @param {object} dest Object to add descriptors to
 * @param {object} src Object to clone descriptors from
 * @param {boolean} [redefine=true] Redefine `dest` properties with `src` properties
 * @returns {object} Reference to dest
 * @public
 */

function merge(dest, src, redefine) {
  if (!dest) {
    throw new TypeError('argument dest is required')
  }

  if (!src) {
    throw new TypeError('argument src is required')
  }

  if (redefine === undefined) {
    // Default to true
    redefine = true
  }

  Object.getOwnPropertyNames(src).forEach(function forEachOwnPropertyName(name) {
    if (!redefine && hasOwnProperty.call(dest, name)) {
      // Skip desriptor
      return
    }

    // Copy descriptor
    var descriptor = Object.getOwnPropertyDescriptor(src, name)
    Object.defineProperty(dest, name, descriptor)
  })

  return dest
}


/***/ }),

/***/ "b645":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* eslint-disable key-spacing */

/* unused harmony default export */ var _unused_webpack_default_export = ({
  /**
   *@description viewer.scene.camera
   */
  moveStart: { name: "moveStart" },
  moveEnd: { name: "moveEnd" },
  /**
   *@description ScreenSpaceEventType
   */
  leftDown: { name: "leftDown" },
  rightDown: { name: "rightDown" }
});


/***/ }),

/***/ "b963":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* WEBPACK VAR INJECTION */(function(global) {/* harmony import */ var _lib_withEvents__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__("cee6");
/* harmony import */ var _events__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__("b645");
/* harmony import */ var _options__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__("64c2");
//
//
//
//
//
//
//
//
//
//
//





/* harmony default export */ __webpack_exports__["a"] = ({
  name: "cesium-web-globe",

  mixins: [_lib_withEvents__WEBPACK_IMPORTED_MODULE_0__[/* default */ "a"]],

  props: {
    cesium: {
      type: Object,
      default: null
    },
    ..._options__WEBPACK_IMPORTED_MODULE_2__[/* default */ "a"]
  },

  data () {
    return {
      initial: true,
      initialized: false
    };
  },

  methods: {

  },

  created () {
    this.webGlobe = null;
    this.propsIsUpdating = {};
    this.cesiumPromise = this.cesium
      ? Promise.resolve(this.cesium)
      : __webpack_require__.e(/* import() */ 1).then(__webpack_require__.t.bind(null, "56d4", 7));
  },

  mounted () {
    const { init, beforeInit } = this;
    this.$_loadCss();
    this.$_loadMap().then(webGlobe => {
      this.webGlobe = webGlobe;
    });
/*     const eventNames = Object.keys(mapEvents);
    this.$_bindMapEvents(eventNames);
    this.$_registerAsyncActions(map);
    this.$_bindPropsUpdateEvents(); */
    this.initial = false;
    this.initialized = true;
    this.$emit("load", { webGlobe, component: this });
  },

  beforeDestroy () {
    this.$nextTick(() => {
      if (global.Cesium) {
        this.webGlobe.viewer.destroy();
        this.webGlobe = null;
        this.viewer = null;
        this.isLoad = false;
        global.Cesium = null;
      }
    });
  }
});

/* WEBPACK VAR INJECTION */}.call(this, __webpack_require__("c8ba")))

/***/ }),

/***/ "c8ba":
/***/ (function(module, exports) {

var g;

// This works in non-strict mode
g = (function() {
	return this;
})();

try {
	// This works if eval is allowed (see CSP)
	g = g || new Function("return this")();
} catch (e) {
	// This works if the window reference is available
	if (typeof window === "object") g = window;
}

// g can still be undefined, but nothing to do about it...
// We return undefined, instead of nothing here, so it's
// easier to handle this case. if(!global) { ...}

module.exports = g;


/***/ }),

/***/ "cee6":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony default export */ __webpack_exports__["a"] = ({
  methods: {
    /**
     * Emit Vue event with additional data
     *
     * @param {string} name EventName
     * @param {Object} [data={}] Additional data
     */
    $_emitEvent(name, data = {}) {
      this.$emit(name, {
        map: this.map,
        component: this,
        ...data
      });
    },

    /**
     * Emit Vue event with Mapbox event as additional data
     *
     * @param {Object} event
     */
    $_emitMapEvent(event, data = {}) {
      this.$_emitEvent(event.type, { cesiumEvent: event, ...data });
    }
  }
});


/***/ }),

/***/ "f6fd":
/***/ (function(module, exports) {

// document.currentScript polyfill by Adam Miller

// MIT license

(function(document){
  var currentScript = "currentScript",
      scripts = document.getElementsByTagName('script'); // Live NodeList collection

  // If browser needs currentScript polyfill, add get currentScript() to the document object
  if (!(currentScript in document)) {
    Object.defineProperty(document, currentScript, {
      get: function(){

        // IE 6-10 supports script readyState
        // IE 10+ support stack trace
        try { throw new Error(); }
        catch (err) {

          // Find the second match for the "at" string to get file src url from stack.
          // Specifically works with the format of stack traces in IE.
          var i, res = ((/.*at [^\(]*\((.*):.+:.+\)$/ig).exec(err.stack) || [false])[1];

          // For all scripts on the page, if src matches or if ready state is interactive, return the script tag
          for(i in scripts){
            if(scripts[i].src == res || scripts[i].readyState == "interactive"){
              return scripts[i];
            }
          }

          // If no match, return null
          return null;
        }
      }
    });
  }
})(document);


/***/ }),

/***/ "fb15":
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "CesiumWebGlobe", function() { return /* reexport */ CesiumWebGlobe; });
__webpack_require__.d(__webpack_exports__, "CesiumImageryLayer", function() { return /* reexport */ CesiumImageryLayer; });
__webpack_require__.d(__webpack_exports__, "CesiumGeojsonDatasource", function() { return /* reexport */ CesiumGeojsonDatasource; });
__webpack_require__.d(__webpack_exports__, "VERSION", function() { return /* reexport */ VERSION; });
__webpack_require__.d(__webpack_exports__, "install", function() { return /* reexport */ src_plugin; });
__webpack_require__.d(__webpack_exports__, "WebGlobe", function() { return /* reexport */ WebGlobe_namespaceObject; });
__webpack_require__.d(__webpack_exports__, "ImageryLayer", function() { return /* reexport */ ImageProvider_namespaceObject; });
__webpack_require__.d(__webpack_exports__, "MapboxImageryProvider", function() { return /* reexport */ Mapbox_namespaceObject; });
__webpack_require__.d(__webpack_exports__, "CustomImageryProvider", function() { return /* reexport */ Custom_namespaceObject; });
__webpack_require__.d(__webpack_exports__, "GeoJsonDataSource", function() { return /* reexport */ Geojson_namespaceObject; });

// NAMESPACE OBJECT: ./src/components/WebGlobe/WebGlobe.vue
var WebGlobe_namespaceObject = {};
__webpack_require__.r(WebGlobe_namespaceObject);
__webpack_require__.d(WebGlobe_namespaceObject, "default", function() { return WebGlobe; });

// NAMESPACE OBJECT: ./src/components/Provider/ImageProvider/index.js
var ImageProvider_namespaceObject = {};
__webpack_require__.r(ImageProvider_namespaceObject);
__webpack_require__.d(ImageProvider_namespaceObject, "default", function() { return ImageProvider; });
__webpack_require__.d(ImageProvider_namespaceObject, "ImageryLayer", function() { return ImageryLayer; });
__webpack_require__.d(ImageProvider_namespaceObject, "install", function() { return ImageProvider_plugin; });

// NAMESPACE OBJECT: ./src/components/Provider/ImageProvider/Mapbox/index.js
var Mapbox_namespaceObject = {};
__webpack_require__.r(Mapbox_namespaceObject);
__webpack_require__.d(Mapbox_namespaceObject, "default", function() { return Mapbox; });
__webpack_require__.d(Mapbox_namespaceObject, "MapboxImageryProvider", function() { return MapboxImageryProvider; });
__webpack_require__.d(Mapbox_namespaceObject, "install", function() { return Mapbox_plugin; });

// NAMESPACE OBJECT: ./src/components/Provider/ImageProvider/Custom/index.js
var Custom_namespaceObject = {};
__webpack_require__.r(Custom_namespaceObject);
__webpack_require__.d(Custom_namespaceObject, "default", function() { return Custom; });
__webpack_require__.d(Custom_namespaceObject, "CustomImageryProvider", function() { return CustomImageryProvider; });
__webpack_require__.d(Custom_namespaceObject, "install", function() { return Custom_plugin; });

// NAMESPACE OBJECT: ./src/components/DataSource/Geojson/index.js
var Geojson_namespaceObject = {};
__webpack_require__.r(Geojson_namespaceObject);
__webpack_require__.d(Geojson_namespaceObject, "default", function() { return Geojson; });
__webpack_require__.d(Geojson_namespaceObject, "GeoJsonDataSource", function() { return GeoJsonDataSource; });
__webpack_require__.d(Geojson_namespaceObject, "install", function() { return Geojson_plugin; });

// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/setPublicPath.js
// This file is imported into lib/wc client bundles.

if (typeof window !== 'undefined') {
  if (true) {
    __webpack_require__("f6fd")
  }

  var setPublicPath_i
  if ((setPublicPath_i = window.document.currentScript) && (setPublicPath_i = setPublicPath_i.src.match(/(.+\/)[^/]+\.js(\?.*)?$/))) {
    __webpack_require__.p = setPublicPath_i[1] // eslint-disable-line
  }
}

// Indicate to webpack that this file can be concatenated
/* harmony default export */ var setPublicPath = (null);

// CONCATENATED MODULE: ./node_modules/cache-loader/dist/cjs.js?{"cacheDirectory":"node_modules/.cache/vue-loader","cacheIdentifier":"436df7d5-vue-loader-template"}!./node_modules/vue-loader/lib/loaders/templateLoader.js??vue-loader-options!./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/WebGlobe/WebGlobe.vue?vue&type=template&id=67cdb098&
var render = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"cesium-map-wrapper"},[_vm._m(0),(_vm.initialized)?_vm._t("default"):_vm._e()],2)}
var staticRenderFns = [function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{ref:"container",attrs:{"id":_vm.container}})}]


// CONCATENATED MODULE: ./src/components/WebGlobe/WebGlobe.vue?vue&type=template&id=67cdb098&

// EXTERNAL MODULE: ./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/WebGlobe/WebGlobe.vue?vue&type=script&lang=js&
var WebGlobevue_type_script_lang_js_ = __webpack_require__("b963");

// CONCATENATED MODULE: ./src/components/WebGlobe/WebGlobe.vue?vue&type=script&lang=js&
 /* harmony default export */ var WebGlobe_WebGlobevue_type_script_lang_js_ = (WebGlobevue_type_script_lang_js_["a" /* default */]); 
// EXTERNAL MODULE: ./src/components/WebGlobe/WebGlobe.vue?vue&type=style&index=0&lang=css&
var WebGlobevue_type_style_index_0_lang_css_ = __webpack_require__("5680");

// CONCATENATED MODULE: ./node_modules/vue-loader/lib/runtime/componentNormalizer.js
/* globals __VUE_SSR_CONTEXT__ */

// IMPORTANT: Do NOT use ES2015 features in this file (except for modules).
// This module is a runtime utility for cleaner component module output and will
// be included in the final webpack user bundle.

function normalizeComponent (
  scriptExports,
  render,
  staticRenderFns,
  functionalTemplate,
  injectStyles,
  scopeId,
  moduleIdentifier, /* server only */
  shadowMode /* vue-cli only */
) {
  // Vue.extend constructor export interop
  var options = typeof scriptExports === 'function'
    ? scriptExports.options
    : scriptExports

  // render functions
  if (render) {
    options.render = render
    options.staticRenderFns = staticRenderFns
    options._compiled = true
  }

  // functional template
  if (functionalTemplate) {
    options.functional = true
  }

  // scopedId
  if (scopeId) {
    options._scopeId = 'data-v-' + scopeId
  }

  var hook
  if (moduleIdentifier) { // server build
    hook = function (context) {
      // 2.3 injection
      context =
        context || // cached call
        (this.$vnode && this.$vnode.ssrContext) || // stateful
        (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext) // functional
      // 2.2 with runInNewContext: true
      if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__
      }
      // inject component styles
      if (injectStyles) {
        injectStyles.call(this, context)
      }
      // register component module identifier for async chunk inferrence
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier)
      }
    }
    // used by ssr in case component is cached and beforeCreate
    // never gets called
    options._ssrRegister = hook
  } else if (injectStyles) {
    hook = shadowMode
      ? function () { injectStyles.call(this, this.$root.$options.shadowRoot) }
      : injectStyles
  }

  if (hook) {
    if (options.functional) {
      // for template-only hot-reload because in that case the render fn doesn't
      // go through the normalizer
      options._injectStyles = hook
      // register for functional component in vue file
      var originalRender = options.render
      options.render = function renderWithStyleInjection (h, context) {
        hook.call(context)
        return originalRender(h, context)
      }
    } else {
      // inject component registration as beforeCreate hook
      var existing = options.beforeCreate
      options.beforeCreate = existing
        ? [].concat(existing, hook)
        : [hook]
    }
  }

  return {
    exports: scriptExports,
    options: options
  }
}

// CONCATENATED MODULE: ./src/components/WebGlobe/WebGlobe.vue






/* normalize component */

var component = normalizeComponent(
  WebGlobe_WebGlobevue_type_script_lang_js_,
  render,
  staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* harmony default export */ var WebGlobe = (component.exports);
// EXTERNAL MODULE: ./node_modules/merge-descriptors/index.js
var merge_descriptors = __webpack_require__("a47c");
var merge_descriptors_default = /*#__PURE__*/__webpack_require__.n(merge_descriptors);

// CONCATENATED MODULE: ./src/components/Utils/mergeDescriptors.js


/**
 * @param {...Object} args
 * @returns {Object}
 */
function multiMergeDescriptors (...args) {
  let redefine
  if (typeof args[args.length - 1] !== 'object') {
    redefine = args.pop()
  }

  return args.slice(1).reduce(
    (dest, src, i) => merge_descriptors_default()(dest, src, redefine),
    args[0]
  )
}

// CONCATENATED MODULE: ./src/components/Base/Cesium/ClassMap.js
/**
 * Vue 组件名对应的 Cesium 类。
 * @const {Object}
 */
const ClassMap = {
  // 二、三维视图
  'vue-web-globe' : 'WebGlobe', //这是我们中地特有的封装，适应OCX的代码
  'vue-viewer': 'Viewer',
  // 影像
  'vue-layer-imagery': 'ImageryLayer',
  'vue-provider-imagery-mapbox': 'MapboxImageryProvider',
  'vue-provider-imagery-openstreetmap': 'OpenStreetMapImageryProvider',
  'vue-provider-imagery-tile-single': 'SingleTileImageryProvider',
  'vue-provider-imagery-tile-coordinates': 'TileCoordinatesImageryProvider',
  'vue-provider-imagery-tile-mapservice': 'TileMapServiceImageryProvider',
  'vue-provider-imagery-urltemplate': 'UrlTemplateImageryProvider',
  'vue-provider-imagery-wms': 'WebMapServiceImageryProvider',
  'vue-provider-imagery-wmts': 'WebMapTileServiceImageryProvider',
  'vue-provider-imagery-tianditu': 'TiandituImageryProvider',
  'vue-provider-imagery-tiledcache ': 'UrlTemplateImageryProvider',
  // 地形
  'vue-provider-terrain-cesium': 'CesiumTerrainProvider',
  // 实体
  'vue-entity': 'Entity',
  'vue-graphics-point': 'PointGraphics',
  'vue-graphics-polygon': 'PolygonGraphics',
  'vue-graphics-polyline': 'PolylineGraphics',
  // 数据源
  'vue-datasource-custom': 'CustomDataSource',
  'vue-datasource-czml': 'CzmlDataSource',
  'vue-datasource-geojson': 'GeoJsonDataSource',
  'vue-datasource-kml': 'KmlDataSource',
  // 图元集合
  'vue-collection-primitive': 'PrimitiveCollection',
  'vue-collection-primitive-billboard': 'BillboardCollection',
  'vue-collection-primitive-label': 'LabelCollection',
  'vue-collection-primitive-point': 'PointPrimitiveCollection',
  'vue-collection-primitive-polyline': 'PolylineCollection',
  // 几何体
  'vue-instance-geometry': 'GeometryInstance',
  'vue-geometry-circle': 'CircleGeometry',
  'vue-geometry-polyline': 'PolylineGeometry',
  'vue-geometry-polygon': 'PolygonGeometry'
}

/* harmony default export */ var Cesium_ClassMap = (ClassMap);

// CONCATENATED MODULE: ./src/components/Utils/util.js
const checkType = (val) => Object.prototype.toString.call(val).slice(8, -1)

const toKebabCase = (str) => str.replace(/[A-Z]/g, (letter) => `-${letter.toLowerCase()}`).replace(/^-/, '')
/**
 * 通过 class 名获取 Dom 元素。
 * @param {Array<Element>} htmlCollection Dom元素集合。
 * @param {String} className class 名称。
 */
const getDocumentByClassName = (htmlCollection, className) => {
  let temp
  const BreakException = {}
  try {
    Array.prototype.slice.call(htmlCollection).forEach((element) => {
      if (element.className === className) {
        temp = element
        throw BreakException
      }
    })
  } catch (e) {
    if (e !== BreakException) throw e
  }
  return temp
}
/**
 * 判断传入的对象是否是方法。
 * @param {*} value
 * @returns {Boolean}
 */
function isFunction (value) {
  return typeof value === 'function'
}
/**
 * 验证是否是经纬度。
 * @param {Number} longitude
 * @param {Number} latitude
 * @returns {Boolean}
 */
function lnglatValidator (longitude, latitude) {
  // 经度，整数部分为0-180小数部分为0到6位
  const longreg = /^(-|\+)?(((\d|[1-9]\d|1[0-7]\d|0{1,3})\.\d{0,15})|(\d|[1-9]\d|1[0-7]\d|0{1,3})|180\.0{0,15}|180)$/
  if (!longreg.test(longitude)) {
    return false
  } // 纬度,整数部分为0-90小数部分为0到6位
  const latreg = /^(-|\+)?([0-8]?\d{1}\.\d{0,15}|90\.0{0,15}|[0-8]?\d{1}|90)$/
  if (!latreg.test(latitude)) {
    return false
  }
  return true
}
/**
 * 普通对象 {x: number, y: number } 转换为 Cesium.Cartesian2 对象
 * @param {Object} val
 * @returns {Object}
 */
function makeCartesian2 (val) {
  return val && new Cesium.Cartesian2(val.x, val.y)
}

/**
 * 普通对象 {x: number, y: number, z: number } 转换为 Cesium.Cartesian3 对象
 * @param {Object} val
 * @returns {Object}
 */
function makeCartesian3 (val) {
  if (val && Object.prototype.hasOwnProperty.call(val, 'x')) {
    return new Cesium.Cartesian3(val.x, val.y, val.z)
  } else if (val && Object.prototype.hasOwnProperty.call(val, 'lng')) {
    return Cesium.Cartesian3.fromDegrees(val.lng, val.lat, val.height)
  }
  return val
}

/**
 * 普通数组 [lng, lat, height, ……，lng, lat, height] 转换为 Cesium.Cartesian3 数组
 * @param {Array} val
 * @returns {Array<Cartesian3>}
 */
function makeCartesian3Array (vals) {
  if (vals && vals instanceof Array && vals[0] instanceof Cesium.Cartesian3) {
    return vals
  }

  const coordinates = []
  vals.forEach((item) => {
    coordinates.push(item.lng)
    coordinates.push(item.lat)
    coordinates.push(item.height)
  })

  return coordinates.length >= 3 ? Cesium.Cartesian3.fromDegreesArrayHeights(coordinates) : vals
}
/**
 * 普通数组 [lng, lat, ……，lng, lat] 转换为 Cesium.Cartesian2 数组
 * @param {Array} vals
 * @returns {Array<Cartesian2>}
 */
function makeCartesian2Array (vals) {
  const cartesian2Array = []
  vals.forEach((item) => {
    cartesian2Array.push(new Cesium.Cartesian2(item.x, item.y))
  })
  return cartesian2Array
}

/**
 *
 * @param {Object} val
 */
function makeQuaternion (val) {
  return val.x ? new Cesium.Quaternion(val.x, val.y, val.z, val.w) : val
}

/**
 * 解析 HierarchyJson
 * @param {Object} val
 */
function parsePolygonHierarchyJson (val) {
  val.forEach((element) => {
    element.positions = makeCartesian3Array(element.positions)
    if (element.holes) {
      parsePolygonHierarchyJson(element.holes)
    }
  })
}

/**
 * 普通数组或对象转 Cesium.PolygonHierarchy 对象。
 * @param {Object|Array} val
 */
function makePolygonHierarchy (val) {
  if (val instanceof Array && val.length >= 3) {
    return new Cesium.PolygonHierarchy(makeCartesian3Array(val))
  }
  if (Cesium.defined(val.positions)) {
    val.positions = makeCartesian3Array(val.positions)
    parsePolygonHierarchyJson(val.holes)
  }

  return val
}
/**
 * 普通对象 {near: number, nearValue: number, far: number, farValue: number} 转 Cesium.NearFarScalar 对象。
 * @param {Object} val
 * @returns {NearFarScalar}
 */
function makeNearFarScalar (val) {
  return val && new Cesium.NearFarScalar(val.near, val.nearValue, val.far, val.farValue)
}
/**
 * 普通对象 {near: number, far: number} 转 Cesium.DistanceDisplayCondition 对象。
 * @param {Object} val
 * @returns {DistanceDisplayCondition}
 */
function makeDistanceDisplayCondition (val) {
  return val && new Cesium.DistanceDisplayCondition(val.near, val.far)
}
/**
 * 普通对象或数组 [r, g, b, a] 或字符串转 Cesium.Color 对象。
 * @param {String|Array|Object} val
 * @returns {Color}
 */
function makeColor (val) {
  if (val instanceof Cesium.Color) {
    return val
  } else if (val instanceof Array) {
    return new Cesium.Color(val[0], val[1], val[2], val[3])
  } else if (typeof val === 'string') {
    return Cesium.Color.fromCssColorString(val)
  }
  return val
}
/**
 * 普通对象或数组 [r, g, b, a] 或字符串转 Material
 * @param {String|Array|Object} val
 */
function makeMaterial (val) {
  if (
    val instanceof Array ||
    (typeof val === 'string' && !/(.*)\.(jpg|bmp|gif|ico|pcx|jpeg|tif|png|raw|tga)$/.test(val))
  ) {
    return makeColor(val)
  }
  // else if (val && val.hasOwnProperty('fabric')) {
  //   return new Cesium.Material({
  //     fabric: {
  //       type: 'Color',
  //       uniforms: {
  //         color: new Cesium.Color(1.0, 1.0, 0.0, 1.0)
  //       }
  //     }
  //   })
  // }
  return val
}
/**
 * 普通对象 {west: number, south: number, east: number, north: number} 转 Cesium.Rectangle 对象。
 * @param {Object} val
 * @returns {Rectangle}
 */
function makeRectangle (val) {
  // Entiy 的 rectangle 属性不能调用这个方法
  if (val instanceof Cesium.RectangleGraphics) {
    return val
  }
  return val && Cesium.Rectangle.fromDegrees(val.west, val.south, val.east, val.north)
}
/**
 * 普通对象 {x: number, y: number, width: number, height: number} 转 Cesium.BoundingRectangle 对象。
 * @param {Object} val
 * @returns {BoundingRectangle}
 */
function makeBoundingRectangle (val) {
  return val && new Cesium.BoundingRectangle(val.x, val.y, val.width, val.height)
}
/**
 * 普通对象 {normal: number, distance: number} 转 Cesium.Plane 对象。
 * @param {Object} val
 * @returns {Plane}
 */
function makePlane (val) {
  // Entiy 和 PlaneGraphics 都有个 plane 属性 要区别一下
  if (val instanceof Cesium.PlaneGraphics) {
    return val
  }
  if (val) {
    Cesium.Cartesian3.normalize(makeCartesian3(val.normal), val.normal)
    return new Cesium.Plane(val.normal, val.distance)
  }
  return val
}

/**
 * 普通对象转平移、旋转、缩放变换对象。
 * @param {*} val
 */
function makeTranslationRotationScale (val) {
  return (
    val &&
    new Cesium.TranslationRotationScale(
      makeCartesian3(val.translation),
      makeQuaternion(val.rotation),
      makeCartesian3(val.scale)
    )
  )
}

function makeOptions (val) {
  const cmpName = this.$options.name
  switch (cmpName) {
    case 'vc-datasource-geojson':
      const result = {}
      Object.assign(result, val)
      result && result.markerColor && (result.markerColor = makeColor(result.markerColor))
      result && result.stroke && (result.stroke = makeColor(result.stroke))
      result && result.fill && (result.fill = makeColor(result.fill))
      return result
  }
  return val
}

function dirname (path) {
  if (typeof path !== 'string') path = path + ''
  if (path.length === 0) return '.'
  var code = path.charCodeAt(0)
  var hasRoot = code === 47 /* / */
  var end = -1
  var matchedSlash = true
  for (var i = path.length - 1; i >= 1; --i) {
    code = path.charCodeAt(i)
    if (code === 47 /* / */) {
      if (!matchedSlash) {
        end = i
        break
      }
    } else {
      // We saw the first non-path separator
      matchedSlash = false
    }
  }

  if (end === -1) return hasRoot ? '/' : '.'
  if (hasRoot && end === 1) {
    // return '//';
    // Backwards-compat fix:
    return '/'
  }
  return path.slice(0, end)
}

function Platform () {
  var ua = navigator.userAgent
  var isWindowsPhone = /(?:Windows Phone)/.test(ua)
  var isSymbian = /(?:SymbianOS)/.test(ua) || isWindowsPhone
  var isAndroid = /(?:Android)/.test(ua)
  var isFireFox = /(?:Firefox)/.test(ua)
  var isChrome = /(?:Chrome|CriOS)/.test(ua)
  var isTablet = /(?:iPad|PlayBook)/.test(ua) || (isAndroid && !/(?:Mobile)/.test(ua)) || (isFireFox && /(?:Tablet)/.test(ua))
  var isPhone = /(?:iPhone)/.test(ua) && !isTablet
  var isPc = !isPhone && !isAndroid && !isSymbian
  return {
    isTablet: isTablet,
    isPhone: isPhone,
    isAndroid: isAndroid,
    isPc: isPc,
    isChrome: isChrome
  }
}

function captureScreenshot (viewer, showSplitter = false) {
  const { when } = Cesium
  const deferred = when.defer()
  const scene = viewer.scene
  var removeCallback = scene.postRender.addEventListener(function () {
    removeCallback()
    try {
      const cesiumCanvas = viewer.scene.canvas

      // If we're using the splitter, draw the split position as a vertical white line.
      let canvas = cesiumCanvas
      // if (showSplitter) {
      //   canvas = document.createElement('canvas')
      //   canvas.width = cesiumCanvas.width
      //   canvas.height = cesiumCanvas.height

      //   const context = canvas.getContext('2d')
      //   context.drawImage(cesiumCanvas, 0, 0)

      //   const x = viewer.splitPosition * cesiumCanvas.width
      //   context.strokeStyle = this.terria.baseMapContrastColor
      //   context.beginPath()
      //   context.moveTo(x, 0)
      //   context.lineTo(x, cesiumCanvas.height)
      //   context.stroke()
      // }

      deferred.resolve(canvas.toDataURL('image/png'))
    } catch (e) {
      deferred.reject(e)
    }
  }, this)

  scene.render(viewer.clock.currentTime)

  return deferred.promise
}

function getAllAttribution (viewer) {
  const credits = viewer.scene.frameState.creditDisplay._currentFrameCredits.screenCredits.values.concat(
    viewer.scene.frameState.creditDisplay._currentFrameCredits.lightboxCredits.values
  )
  return credits.map(credit => credit.html)
}

// CONCATENATED MODULE: ./src/components/Base/Cesium/ClassProps.js


/**
 * 特殊的 Props, 需要用 util 中提供的方法转换。
 */
const ClassProps = {
  distanceDisplayCondition: {
    handler: makeDistanceDisplayCondition
  },
  pixelOffset: {
    handler: makeCartesian2,
    deep: true
  },
  showBackground: {
    handler: makeCartesian2,
    deep: true
  },
  imageBasedLightingFactor: {
    handler: makeCartesian2
  },
  shape: {
    handler: makeCartesian2Array
  },
  shapePositions: {
    handler: makeCartesian2Array
  },
  position: {
    handler: makeCartesian3
  },
  eyeOffset: {
    handler: makeCartesian3,
    deep: true
  },
  alignedAxis: {
    handler: makeCartesian3,
    deep: true
  },
  dimensions: {
    handler: makeCartesian3
  },
  radii: {
    handler: makeCartesian3
  },
  center: {
    handler: makeCartesian3
  },
  innerRadii: {
    handler: makeCartesian3
  },
  origin: {
    handler: makeCartesian3
  },
  positions: {
    handler: makeCartesian3Array,
    exclude: '_callback'
  },
  polylinePositions: {
    handler: makeCartesian3Array,
    exclude: '_callback'
  },
  color: {
    handler: makeColor
  },
  outlineColor: {
    handler: makeColor
  },
  backgroundColor: {
    handler: makeColor
  },
  fillColor: {
    handler: makeColor
  },
  silhouetteColor: {
    handler: makeColor
  },
  lightColor: {
    handler: makeColor
  },
  glowColor: {
    handler: makeColor
  },
  clearColor: {
    handler: makeColor
  },
  scaleByDistance: {
    handler: makeNearFarScalar
  },
  translucencyByDistance: {
    handler: makeNearFarScalar
  },
  pixelOffsetScaleByDistance: {
    handler: makeNearFarScalar
  },
  material: {
    handler: makeMaterial
  },
  depthFailMaterial: {
    handler: makeMaterial
  },
  cutoutRectangle: {
    handler: makeRectangle
  },
  coordinates: {
    handler: makeRectangle
  },
  rectangle: {
    handler: makeRectangle
  },
  imageSubRegion: {
    handler: makeBoundingRectangle
  },
  colorToAlpha: {
    handler: makeColor
  },
  plane: {
    handler: makePlane
  },
  hierarchy: {
    handler: makePolygonHierarchy,
    exclude: '_callback'
  },
  polygonHierarchy: {
    handler: makePolygonHierarchy
  },
  nodeTransformations: {
    handler: makeTranslationRotationScale
  },
  orientation: {
    handler: makeQuaternion
  },
  options: {
    deep: true,
    handler: makeOptions
  }
}

/* harmony default export */ var Cesium_ClassProps = (ClassProps);

// CONCATENATED MODULE: ./src/components/Base/Service/CommonServices.js


const SERVICES_PROP = 'services'
/**
 * 全局注入 provider 的数据
 */
/* harmony default export */ var CommonServices = ({
  inject: {
    $services: SERVICES_PROP
  },
  provide () {
    return {
      [SERVICES_PROP]: this.getServices()
    }
  },
  methods: {
    /**
     *  获取注入数据。
     * @returns {Object}
     * @protected
     */
    getServices () {
      return multiMergeDescriptors({}, this.$services || {})
    },
    /**
     * 移除对象中的空值。
     * @param {*} o
     * @param {*} arr
     * @param {*} i
     * @returns {Object}
     */
    removeNullItem (o, arr, i) {
      var s = {}.toString.call(o)
      if (s === '[object Array]') {
        if (this.processArray(o) === true) {
          // o也是数组，并且删除完子项，从所属数组中删除
          // if (arr) arr.splice(i, 1);
        }
      } else if (s === '[object Object]') {
        this.proccessObject(o)
        // if (arr&&isEmptyObj(o)) arr.splice(i, 1);
      }
    },
    /**
     * 判断是否是空对象。
     * @param {*} o
     * @returns {Boolean}
     */
    isEmptyObj (o) {
      for (var attr in o) return !1
      return !0
    },
    /**
     * 处理数组。
     * @param {*} arr
     */
    processArray (arr) {
      for (var i = arr.length - 1; i >= 0; i--) {
        /* if (arr[i] === null || arr[i] === undefined) arr.splice(i, 1);
            else */ if (
          typeof arr[i] === 'object'
        ) {
          this.removeNullItem(arr[i], arr, i)
        }
      }
      return arr.length === 0
    },
    /**
     * 处理对象。
     * @param {*} o
     */
    proccessObject (o) {
      for (var attr in o) {
        if (o[attr] === null || o[attr] === undefined) delete o[attr]
        else if (typeof o[attr] === 'object') {
          // this.removeNullItem(o[attr])
          if (this.isEmptyObj(o[attr])) delete o[attr]
        }
      }
    }
  },
  beforeCreate () {
    let source = this.$parent
    while (source) {
      if (source._provided != null && source._provided[SERVICES_PROP] != null) {
        break
      }
      source = source.$parent
    }
    if (source == null || source._provided[SERVICES_PROP] == null) {
      delete this.$options.inject.$services
    }
  }
});

// CONCATENATED MODULE: ./src/components/Base/Cesium/CesiumCommon.js




const VM_PROP = 'vm'
/**
 * Get the parent component. 获取父组件方法。
 * @param {VueComponent} $component.
 */
const getParent = function($component){
  return !$component.cesiumClass && $component.$options.name !== 'vue-web-globe' ? getParent($component.$parent) : $component
}

/**
 * @vueMethods
 */
const methods = {
  /**
   * Load components asynchronously. 异步加载组件。
   * @returns {Promise<Object>} { Cesium, viewer, cesiumObject }
   */
  async load () {
    // Returns if it is already loaded. 如果已经加载则返回。
    if (this._mounted) {
      return false 
    }

    const { createCesiumObject, mount, setPropWatchers } = this
    const $parent = getParent(this.$parent)
    
    const Cesium = (this.Cesium = $parent.Cesium)
    const webGlobe = (this.webGlobe = $parent.webGlobe)
    const viewer = (this.viewer = $parent.viewer)
    
    // If you call the unload method to unload the component, the Cesium object of the parent component may be unloaded. You need to load the parent component first.
    // 如果调用过 unload 方法卸载组件，父组件的 Cesium 对象可能会被卸载 需要先加载父组件。
    if (!$parent.cesiumObject) {
      return $parent.load()
    }
    // Register vue Watchers. 注册 Vue 侦听器。
    setPropWatchers(true)
    return createCesiumObject().then(async (cesiumObject) => {
      this.originInstance = cesiumObject
      // Load the created Cesium object. 加载创建的 Cesium 对象。
      return mount().then(() => {
        this._mounted = true
        // Trigger the component's 'ready' event. 触发该组件的 'ready' 事件。
        this.$emit('ready', { Cesium, viewer, webGlobe, cesiumObject, vm: this })
        return { Cesium, viewer, webGlobe, cesiumObject, vm: this }
      })
    })
  },
  /**
   * Unloading components asynchronously. 异步卸载组件。
   * @returns {Promise<Boolean>} returns true on success and false on failure. 成功返回 true，失败返回 false。
   */
  async unload () {
    // If the component has subcomponents, you need to remove the subcomponents first. 如果该组件带有子组件，需要先移除子组件。
    for (const $node of (this.$slots.default || []).map((vnode) => vnode.componentInstance).filter((cmp) => !!cmp)) {
      await $node.unload()
    }
    return this._mounted
      ? this.unmount().then(async () => {
        // Teardown the watchers. 注销 Vue 侦听器。
        this.setPropWatchers(false)
        this.originInstance = undefined
        this._mounted = false
        // If the component cannot be rendered without the parent component, the parent component needs to be removed.
        // 如果该组件的渲染和父组件是绑定在一起的，需要移除父组件。
        return this.renderByParent ? this.$parent.unload() : true
      }) : false
  },
  /**
   * Reload components asynchronously. 异步重载组件.
   * @returns {Promise<Boolean>} returns true on success and false on failure. 成功返回 true，失败返回 false。
   */
  async reload () {
    return this.unload().then(() => {
      return this.load()
    })
  },
  /**
   * Create Cesium objects asynchronously. 异步创建 Cesium 对象。
   * @returns {Promise<Object>} return the Cesium object.
   */
  async createCesiumObject () {
    const { $props, cesiumClass, transformProps } = this
    const options = transformProps($props)
    return new Cesium[cesiumClass](options)
  },
  /**
   * Register or unregister the vue watchers.
   * @param {Boolean} register
   */
  setPropWatchers (register) {
    if (register) {
      const { $props, specialPropsKeys, cesiumClass, cesiumObject, applyToConstructor } = this
      if (!cesiumClass || !Cesium[cesiumClass]) { return }
      const constructor = Cesium[cesiumClass]
      const args = []
      for (let i = 0; i < constructor.length; i++) {
        args.push({})
      }
      // Create a temporary object to get the writability of the current Cesium object or the props on its prototype chain to
      // detect whether the component property responds dynamically or reloads the component when the property changes.
      // 创建一个临时对象来获取当前 Cesium 对象或它原型链上的 prop 的可写性，以检测属性改变时组件属性是动态响应还是重载组件。
      let instance = cesiumObject || applyToConstructor(constructor, args)
      $props && Object.keys($props).forEach(vueProp => {
        let cesiumProp = vueProp
        if (vueProp === 'labelStyle' || vueProp === 'wmtsStyle') {
          cesiumProp = 'style'
        } else if (vueProp === 'bmKey') {
          cesiumProp = 'key'
        }
        const pd = instance && Object.getOwnPropertyDescriptor(instance, cesiumProp)
        const pdProto = instance && Object.getOwnPropertyDescriptor(Object.getPrototypeOf(instance), cesiumProp)
        const hasSetter = (pd && pd.writable) || (pdProto && pdProto.set)
        // returns an unwatch function that stops firing the callback
        const unwatch = this.$watch(
          vueProp,
          async (val) => {
            // Wait for child components to be created.
            // 等待子组件创建完成。否则在父组件的 `ready` 事件中就改变的属性将不起作用。
            await this.createPromise
            if (hasSetter) {
              // Attributes are writable and directly respond to changes in attributes.
              // 属性可写，直接动态响应属性的改变。
              const { cesiumObject } = this

              if (specialPropsKeys.indexOf(vueProp) !== -1 && Cesium_ClassProps[vueProp].handler) {
                const newVal = Cesium_ClassProps[vueProp].handler.call(this, val)
                // If an exclude condition has been defined for the object, such as "_callback", Cesium will automatically handle it internally and no longer need to be assigned.
                // 如果对象已经定义了 exclude 条件，如已经定义了“_callback”，Cesium 内部会自动处理的 不用再赋值了。
                if (!(Cesium.defined(cesiumObject[cesiumProp]) && Cesium.defined(cesiumObject[cesiumProp][Cesium_ClassProps[vueProp].exclude]) && Cesium_ClassProps[vueProp].exclude)) {
                  cesiumObject[cesiumProp] = newVal
                }
              } else {
                cesiumObject[cesiumProp] = val
              }
              return true
            } else {
              // The attribute is not writable, and the property is changed indirectly through reloading the component.
              // 属性不可写，通过重加载组件间接实现改变属性
              return this.reload()
            }
          },
          { deep: specialPropsKeys.indexOf(vueProp) !== -1 && Cesium_ClassProps[vueProp].deep }
        )
        this.unwatchFns.push(unwatch)
      })
      // Destroy temporary objects.
      // 销毁临时对象
      instance && Cesium.destroyObject(instance)
      instance = null
    } else {
      // Stops firing the callback.
      // 注销 watchers。
      this.unwatchFns.forEach((item) => item())
      this.unwatchFns = []
    }
  },
  /**
   * Use the apply method to call the Cesium constructor to initialize the Cesium instance. 使用 apply 调用 Cesium 构造函数初始化 Cesium 实例。
   * @param {Function} constructor Cesium 构造函数。
   * @param {Array} argArray 构造函数参数。
   * @returns {Object} 返回 Cesium 实例。
   */
  applyToConstructor (constructor, argArray) {
    let instance
    try {
      const args = [{}].concat(argArray)
      // 动态创建 Cesium 临时实例，大部分都能正常创建，但有部分参数是不可省略的，暂时没想到更好的办法
      // args[1].url = ''
      args[1].mapId = {}
      args[1].geometry = {}
      args[1].rectangle = Cesium.Rectangle.MAX_VALUE
      args[1].polygonHierarchy = {}
      args[1].assetId = 1
      args[1].layers = ''
      args[2] = new Cesium.PolylineCollection({})

      const FactoryFunction = constructor.bind.apply(constructor, args)
      instance = new FactoryFunction()
    } catch (e) {
      if (Object({"NODE_ENV":"production","BASE_URL":"/"}).VUECESIUM_DEBUG) {
        /* Cannot get final name for export "warn" in "./src/components/Utils/util.js" (known exports: checkType toKebabCase getDocumentByClassName isFunction lnglatValidator makeCartesian2 makeCartesian3 makeCartesian3Array makeCartesian2Array makeQuaternion makePolygonHierarchy makeNearFarScalar makeDistanceDisplayCondition makeColor makeMaterial makeRectangle makeBoundingRectangle makePlane makeTranslationRotationScale makeOptions dirname Platform captureScreenshot getAllAttribution, known reexports: ) */ undefined(e)
      }
    }
    return instance
  },
  /**
   * Mount Cesium objects asynchronously. 异步挂载 Cesium 对象，即将 Cesium 对象添加到 viewer 中。虚方法，在各 vue 组件中实现。
   * @returns {Promise<Boolean>} 操作成功返回 true，失败返回 false。
   */
  async mount () {
    return true
  },
  /**
   * Unmount Cesium objects asynchronously. 异步卸载 Cesium 对象，即将 Cesium 对象从 viewer 移除。虚方法，在各 vue 组件中实现。
   * @returns {Promise<Boolean>} 操作成功返回 true，失败返回 false。
   */
  async unmount () {
    return true
  },
  /**
   * Get the injected object. 获取注入的对象。主要是为了获取父组件和父组件的 Cesium 对象。
   * @returns {Object}
   */
  getServices () {
    return CommonServices.methods.getServices.call(this)
  },
  transformProps (props) {
    const { specialPropsKeys, isEmptyObj } = this
    const options = {}
    props && Object.keys(props).forEach((vueProp) => {
      let cesiumProp = vueProp
      // The properties of the following Cesium instance objects are HTML or Vue reserved words and require special handling.
      // 以下 Cesium 实例对象的属性是 HTML 或 Vue 保留字，需要特别处理一下。
      if (vueProp === 'labelStyle' || vueProp === 'wmtsStyle') {
        cesiumProp = 'style'
      } else if (vueProp === 'bmKey') {
        cesiumProp = 'key'
      }
      options[cesiumProp] =
        specialPropsKeys.indexOf(vueProp) !== -1 && Cesium_ClassProps[vueProp].handler && !isEmptyObj(props[vueProp])
          ? Cesium_ClassProps[vueProp].handler.call(this, props[vueProp])
          : props[vueProp]
    })
    // Remove empty objects to avoid initialization errors when Cesium objects are initialized with null values.
    // 移除空对象，避免 Cesium 对象初始化时传入空值导致初始化报错。
    this.removeNullItem(options)
    return options
  },
  /**
   * The action before the component is loaded. 组件加载前的操作。
   */
  async beforeLoad () {
    await this.$parent.createPromise
  }
}
/**
 * VueCesium common minxin
 */
/* harmony default export */ var CesiumCommon = ({
  VM_PROP,
  mixins: [CommonServices],
  methods,
  data () {
    return {
      unwatchFns: []
    }
  },
  created () {
    this._mounted = false
    this.cesiumClass = Cesium_ClassMap[this.$options.name]

    this.specialPropsKeys = Object.keys(Cesium_ClassProps)
    const { beforeLoad, load } = this
    const $parent = getParent(this.$parent)
    
    // this._createPromise = Promise.resolve(beforeLoad()).then(() => load())
    this._createPromise = Promise.resolve(beforeLoad()).then(() => {
      return new Promise((resolve, reject) => {
        const viewer = $parent.viewer
        viewer && resolve(load())
        $parent.$on('ready', () => {
          resolve(load())
          // .then(val => resolve(val))
          // .catch((error) => reject(new Error(`[C_PKG_FULLNAME] ERROR: An error occurred during the initialization of the ${this.cesiumClass}!` + error)))
        })
      })
    })

    Object.defineProperties(this, {
      createPromise: {
        enumerable: true,
        get: () => this._createPromise
      },
      cesiumObject: {
        enumerable: true,
        get: () => this.originInstance
      },
      mounted: {
        enumerable: true,
        get: () => this._mounted
      }
    })
  },
  destroyed () {
    this.unload().then(() => {
      this.$emit('destroyed', this)
    })
  }
});

// CONCATENATED MODULE: ./src/components/Base/Vue/VueHelpers.js
/**
 * Constructs watch hash for multiple properties.
 * @param {string[]} props
 * @param {function|Object} watcherFactory
 */
function makeWatchers (props, watcherFactory) {
  return props.reduce((hash, prop) => {
    hash[prop] = watcherFactory(prop)
    return hash
  }, {})
}

function extractChildren (slots, slotNames = []) {
  return Object.keys(slots).reduce((all, name) => {
    if (!slotNames.length || slotNames.includes(name)) {
      all = all.concat(slots[name])
    }

    return all
  }, [])
}

// CONCATENATED MODULE: ./src/components/Base/Vue/VueVirtualNode.js


/**
 * Renders stub VNode for component.
 */
/* harmony default export */ var VueVirtualNode = ({
  /**
   * @param {function} h
   * @returns {VNode}
   */
  render (h) {
    const options = this.$options.stubVNode || {}
    // render as HTML comment
    if (options.empty) {
      const vnode = h()
      if (typeof options.empty === 'string') {
        vnode.text = options.empty
      } else if (typeof options.empty === 'function') {
        vnode.text = options.empty.call(this)
      }

      return vnode
    }

    let children
    if (options.slots === false) {
      children = undefined
    } else {
      children = extractChildren(this.$slots, options.slots)
    }

    const attrs = typeof options.attrs === 'function'
      ? options.attrs.call(this)
      : options.attrs

    const data = {
      attrs,
      style: {
        display: 'none !important'
      }
    }

    return h(options.tag || 'i', data, children)
  }
});

// CONCATENATED MODULE: ./src/components/Base/Vue/VueVirtualCmp.js


/**
 * VueCesium 的基础虚拟组件，mixin 注入需要实现以下方法。
 */
/* harmony default export */ var VueVirtualCmp = ({
  mixins: [VueVirtualNode, CesiumCommon],
  methods: {
    /**
     * 获取注入对象。
     * @returns {Object}
     */
    getServices () {
      return CesiumCommon.methods.getServices.call(this)
    },
    /**
     * 加载组件。
     * @returns {Promise}
     */
    load () {
      return CesiumCommon.methods.load.call(this)
    },
    /**
     * 重载组件。
     * @returns {Promise}
     */
    reload () {
      return CesiumCommon.methods.reload.call(this)
    },
    /**
     * 卸载组件。
     * @return {Promise}
     */
    unload () {
      return CesiumCommon.methods.unload.call(this)
    }
  }
});

// CONCATENATED MODULE: ./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/Provider/ImageProvider/ImageryLayer.vue?vue&type=script&lang=js&



/* harmony default export */ var ImageryLayervue_type_script_lang_js_ = ({
  name: 'vue-layer-imagery',
  mixins: [VueVirtualCmp],
  props: {
    imageryProvider: Object,
    rectangle: Object,
    alpha: {
      type: Number | Function,
      default: 1.0
    },
    brightness: {
      type: Number | Function,
      default: 1.0
    },
    contrast: {
      type: Number | Function,
      default: 1.0
    },
    hue: {
      type: Number | Function,
      default: 0.0
    },
    saturation: {
      type: Number | Function,
      default: 1.0
    },
    gamma: {
      type: Number | Function,
      default: 1.0
    },
    splitDirection: Number,
    minificationFilter: Number,
    magnificationFilter: Number,
    show: {
      type: Boolean,
      default: true
    },
    maximumAnisotropy: Number,
    minimumTerrainLevel: Number,
    maximumTerrainLevel: Number,
    cutoutRectangle: Object,
    colorToAlpha: Object,
    colorToAlphaThreshold: {
      type: Number,
      default: 0.004
    }
  },
  methods: {
    /**
     * ImageryLayer 初始化方式较为特殊，这儿覆盖重写 createCesiumObject 方法。
     */
    async createCesiumObject () {
      const { $props, transformProps, requiredArg } = this
      const options = transformProps($props)
      return new Cesium.ImageryLayer(requiredArg || {}, options)
    },
    async mount () {
      const { viewer, imageryLayer } = this
      viewer.imageryLayers.add(imageryLayer)
      return !this.viewer.isDestroyed() && viewer.imageryLayers.contains(imageryLayer)
    },
    async unmount () {
      const { viewer, imageryLayer } = this
      return !viewer.isDestroyed() && viewer.imageryLayers.remove(imageryLayer)
    },
    async refresh () {
      return this.unmount().then(() => {
        return this.createCesiumObject().then(cesiumObject => {
          this.originInstance = cesiumObject
          return this.mount()
        })
      })
    },
    setProvider (provider) {
      if (provider !== this._provider) {
        this._provider = provider
        provider && this.refresh()
        const listener = this.$listeners['update:imageryProvider']
        if (listener) this.$emit('update:imageryProvider', provider)
      }
    },
    getServices () {
      const vm = this
      return multiMergeDescriptors(
        VueVirtualCmp.methods.getServices.call(this),
        {
          get imageryLayer () { return vm.imageryLayer },
          get providerContainer () { return vm }
        }
      )
    }
  },
  stubVNode: {
    attrs () {
      return {
        class: this.$options.name
      }
    }
  },
  created () {
    this._provider = undefined
    Object.defineProperties(this, {
      imageryLayer: {
        enumerable: true,
        get: () => this.cesiumObject
      },
      requiredArg: {
        enumerable: true,
        get: () => this.imageryProvider || this._provider
      }
    })
  }
});

// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/ImageryLayer.vue?vue&type=script&lang=js&
 /* harmony default export */ var ImageProvider_ImageryLayervue_type_script_lang_js_ = (ImageryLayervue_type_script_lang_js_); 
// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/ImageryLayer.vue
var ImageryLayer_render, ImageryLayer_staticRenderFns




/* normalize component */

var ImageryLayer_component = normalizeComponent(
  ImageProvider_ImageryLayervue_type_script_lang_js_,
  ImageryLayer_render,
  ImageryLayer_staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* harmony default export */ var ImageryLayer = (ImageryLayer_component.exports);
// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/index.js


function ImageProvider_plugin (Vue, options = {}) {
  if (ImageProvider_plugin.installed) {
    return
  }
  ImageProvider_plugin.installed = true

  Vue.component(ImageryLayer.name, ImageryLayer)
}

/* harmony default export */ var ImageProvider = (ImageProvider_plugin);



// CONCATENATED MODULE: ./src/components/Base/Cesium/CesiumMixinProps.js


/**
 * @const {Object}  position mixin
 */
const position = {
  props: {
    position: {
      type: Object,
      validator: val => {
        return val && Object.prototype.hasOwnProperty.call(val, 'lng') ? lnglatValidator(val.lng, val.lat) : true
      }
    }
  }
}

/**
 * @const {Boolean}  show mixin
 */
const show = {
  props: {
    show: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Object}  distanceDisplayCondition mixin
 */
const distanceDisplayCondition = {
  props: {
    distanceDisplayCondition: Object
  }
}

/**
 * @const {String | Object} image mixin
 */
const CesiumMixinProps_image = {
  props: {
    image: String | Object
  }
}

/**
 * @const {Number} scale mixin
 */
const scale = {
  props: {
    scale: {
      type: Number,
      default: 1.0
    }
  }
}

/**
 * @const {Object}  pixelOffset mixin
 */
const pixelOffset = {
  props: {
    pixelOffset: {
      type: Object,
      default: () => {
        return {
          x: 0,
          y: 0
        }
      }
    }
  }
}

/**
 * @const {Object}  eyeOffset mixin
 */
const eyeOffset = {
  props: {
    eyeOffset: {
      type: Object,
      default: () => {
        return {
          x: 0,
          y: 0,
          z: 0
        }
      }
    }
  }
}

/**
 * @const {Number} horizontalOrigin mixin
 */
const horizontalOrigin = {
  props: {
    horizontalOrigin: {
      type: Number,
      default: 0
    }
  }
}

/**
 * @const {Number}  verticalOrigin mixin
 */
const verticalOrigin = {
  props: {
    verticalOrigin: {
      type: Number,
      default: 0
    }
  }
}

/**
 * @const {Number} heightReference mixin
 */
const heightReference = {
  props: {
    heightReference: Number
  }
}

/**
 * @const {Object|String|Array} color mixin
 */
const color = {
  props: {
    color: {
      type: Object | String | Array,
      default: 'white'
    }
  }
}

/**
 * @const {Number|Object} rotation mixin
 */
const rotation = {
  props: {
    rotation: {
      type: Number | Object,
      default: 0
    }
  }
}

/**
 * @const {Object} alignedAxis mixin
 */
const alignedAxis = {
  props: {
    alignedAxis: {
      type: Object,
      default: () => {
        return {
          x: 0,
          y: 0,
          z: 0
        }
      }
    }
  }
}

/**
 * @const {Boolean} sizeInMeters mixin
 */
const sizeInMeters = {
  props: {
    sizeInMeters: Boolean
  }
}

/**
 * @const {Number} width mixin
 */
const width = {
  props: {
    width: Number
  }
}

/**
 * @const {Number} height mixin
 */
const height = {
  props: {
    height: Number
  }
}

/**
 * @const {Object} scaleByDistance mixin
 */
const scaleByDistance = {
  props: {
    scaleByDistance: Object
  }
}

/**
 * @const {Object} translucencyByDistance mixin
 */
const translucencyByDistance = {
  props: {
    translucencyByDistance: Object
  }
}

/**
 * @const {Object} pixelOffsetScaleByDistance mixin
 */
const pixelOffsetScaleByDistance = {
  props: {
    pixelOffsetScaleByDistance: Object
  }
}

/**
 * @const {Number} disableDepthTestDistance mixin
 */
const disableDepthTestDistance = {
  props: {
    disableDepthTestDistance: Number
  }
}

/**
 * @const {Object} dimensions mixin
 */
const dimensions = {
  props: {
    dimensions: Object
  }
}

/**
 * @const {Boolean} fill mixin
 */
const fill = {
  props: {
    fill: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Object|String|Array} material mixin
 */
const material = {
  props: {
    material: {
      type: Object | String | Array,
      default: 'white'
    }
  }
}

/**
 * @const {Boolean} outline mixin
 */
const outline = {
  props: {
    outline: {
      type: Boolean,
      default: false
    }
  }
}

/**
 * @const {Object|String|Array} outlineColor mixin
 */
const outlineColor = {
  props: {
    outlineColor: {
      type: Object | String | Array,
      default: 'black'
    }
  }
}

/**
 * @const {Number} outlineWidth mixin
 */
const outlineWidth = {
  props: {
    outlineWidth: {
      type: Number,
      default: 1.0
    }
  }
}

/**
 * @const {Number} shadows mixin
 */
const shadows = {
  props: {
    shadows: Number
  }
}

/**
 * @const {Array} positions mixin
 */
const positions = {
  props: {
    positions: Array
  }
}

/**
 * @const {Number} extrudedHeight mixin
 */
const extrudedHeight = {
  props: {
    extrudedHeight: Number
  }
}

/**
 * @const {Number} extrudedHeightReference mixin
 */
const extrudedHeightReference = {
  props: {
    extrudedHeightReference: Number
  }
}

/**
 * @const {Number} cornerType mixin
 */
const cornerType = {
  props: {
    cornerType: {
      type: Number,
      default: 0
    }
  }
}

/**
 * @const {Number} granularity mixin
 */
const granularity = {
  props: {
    granularity: Number
  }
}

/**
 * @const {Number} classificationType mixin
 */
const classificationType = {
  props: {
    classificationType: {
      type: Number,
      default: 2
    }
  }
}

/**
 * @const {Number} zIndex mixin
 */
const zIndex = {
  props: {
    zIndex: Number
  }
}

/**
 * @const {Number} length mixin
 */
const CesiumMixinProps_length = {
  props: {
    length: Number
  }
}

/**
 * @const {Number} topRadius mixin
 */
const topRadius = {
  props: {
    topRadius: Number
  }
}

/**
 * @const {Number} bottomRadius mixin
 */
const bottomRadius = {
  props: {
    bottomRadius: Number
  }
}

/**
 * @const {Number} numberOfVerticalLines mixin
 */
const numberOfVerticalLines = {
  props: {
    numberOfVerticalLines: {
      type: Number,
      default: 16
    }
  }
}

/**
 * @const {Number} slices mixin
 */
const slices = {
  props: {
    slices: {
      type: Number,
      default: 128
    }
  }
}

/**
 * @const {Number} semiMajorAxis mixin
 */
const semiMajorAxis = {
  props: {
    semiMajorAxis: Number
  }
}

/**
 * @const {Number} semiMinorAxis mixin
 */
const semiMinorAxis = {
  props: {
    semiMinorAxis: Number
  }
}

/**
 * @const {Number|Object} stRotation mixin
 */
const stRotation = {
  props: {
    stRotation: {
      type: [Number, Object],
      default: 0.0
    }
  }
}

/**
 * @const {Number} radii mixin
 */
const radii = {
  props: {
    radii: Object
  }
}

/**
 * @const {Number} stackPartitions mixin
 */
const stackPartitions = {
  props: {
    stackPartitions: {
      type: Number,
      default: 64
    }
  }
}

/**
 * @const {Number} slicePartitions mixin
 */
const slicePartitions = {
  props: {
    slicePartitions: {
      type: Number,
      default: 64
    }
  }
}

/**
 * @const {Number} subdivisions mixin
 */
const subdivisions = {
  props: {
    subdivisions: {
      type: Number,
      default: 128
    }
  }
}

/**
 * @const {String} text mixin
 */
const CesiumMixinProps_text = {
  props: {
    text: String
  }
}

/**
 * @const {String} font mixin
 */
const font = {
  props: {
    font: {
      type: String,
      default: '30px sans-serif'
    }
  }
}

/**
 * @const {Number} labelStyle mixin
 */
const labelStyle = {
  props: {
    labelStyle: {
      type: Number,
      default: 0
    }
  }
}

/**
 * @const {Boolean} showBackground mixin
 */
const showBackground = {
  props: {
    showBackground: {
      type: Boolean,
      default: false
    }
  }
}

/**
 * @const {Object/String/Array} backgroundColor mixin
 */
const backgroundColor = {
  props: {
    backgroundColor: {
      type: Object | String | Array,
      default: () => {
        return [0.165, 0.165, 0.165, 0.8]
      }
    }
  }
}

/**
 * @const {Object} backgroundPadding mixin
 */
const backgroundPadding = {
  props: {
    backgroundPadding: {
      type: Object,
      default: () => {
        return { x: 7, y: 5 }
      }
    }
  }
}

/**
 * @const {Object|String|Array} fillColor mixin
 */
const fillColor = {
  props: {
    fillColor: {
      type: Object | String | Array,
      default: 'WHITE'
    }
  }
}

/**
 * @const {String} uri mixin
 */
const uri = {
  props: {
    uri: String
  }
}

/**
 * @const {Number} minimumPixelSize mixin
 */
const minimumPixelSize = {
  props: {
    minimumPixelSize: {
      type: Number,
      default: 0.0
    }
  }
}

/**
 * @const {Number} maximumScale mixin
 */
const maximumScale = {
  props: {
    maximumScale: Number
  }
}

/**
 * @const {Boolean} incrementallyLoadTextures mixin
 */
const incrementallyLoadTextures = {
  props: {
    incrementallyLoadTextures: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Boolean} clampAnimations mixin
 */
const clampAnimations = {
  props: {
    clampAnimations: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Object|String|Array} silhouetteColor mixin
 */
const silhouetteColor = {
  props: {
    silhouetteColor: Object | String | Array
  }
}

/**
 * @const {Number} silhouetteSize mixin
 */
const silhouetteSize = {
  props: {
    silhouetteSize: {
      type: Number,
      default: 0.0
    }
  }
}

/**
 * @const {Number} colorBlendMode mixin
 */
const colorBlendMode = {
  props: {
    colorBlendMode: {
      type: Number,
      default: 0
    }
  }
}

/**
 * @const {Number} colorBlendAmount mixin
 */
const colorBlendAmount = {
  props: {
    colorBlendAmount: {
      type: Number,
      default: 0.5
    }
  }
}

/**
 * @const {Object} clippingPlanes mixin
 */
const clippingPlanes = {
  props: {
    clippingPlanes: Object
  }
}

/**
 * @const {Number} pixelSize mixin
 */
const pixelSize = {
  props: {
    pixelSize: {
      type: Number,
      default: 1
    }
  }
}

/**
 * @const {Boolean} perPositionHeight mixin
 */
const perPositionHeight = {
  props: {
    perPositionHeight: {
      type: Boolean,
      default: false
    }
  }
}

/**
 * @const {Boolean} closeTop mixin
 */
const closeTop = {
  props: {
    closeTop: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Boolean} closeBottom mixin
 */
const closeBottom = {
  props: {
    closeBottom: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Number} arcType mixin
 */
const arcType = {
  props: {
    arcType: {
      type: Number,
      default: 1
    }
  }
}

/**
 * @const Array{} minimumHeights mixin
 */
const minimumHeights = {
  props: {
    minimumHeights: Array
  }
}

/**
 * @const {Array} maximumHeights mixin
 */
const maximumHeights = {
  props: {
    maximumHeights: Array
  }
}

// imageryProvider
/**
 * @const {String|Object} url mixin
 */
const url = {
  props: {
    url: String | Object
  }
}

/**
 * @const {String} token mixin
 */
const token = {
  props: {
    token: String
  }
}

/**
 * @const {Object} tileDiscardPolicy mixin
 */
const tileDiscardPolicy = {
  props: {
    tileDiscardPolicy: Object
  }
}

/**
 * @const {String} layers mixin
 */
const CesiumMixinProps_layers = {
  props: {
    layers: String
  }
}

/**
 * @const {Boolean} enablePickFeatures mixin
 */
const enablePickFeatures = {
  props: {
    enablePickFeatures: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Object} rectangle mixin
 */
const rectangle = {
  props: {
    rectangle: Object
  }
}

/**
 * @const {Object} tilingScheme mixin
 */
const tilingScheme = {
  props: {
    tilingScheme: Object
  }
}

/**
 * @const {Object} ellipsoid mixin
 */
const ellipsoid = {
  props: {
    ellipsoid: Object
  }
}

/**
 * @const {String|Object} credit mixin
 */
const credit = {
  props: {
    credit: {
      type: String | Object,
      default: ''
    }
  }
}

/**
 * @const {Number} tileWidth mixin
 */
const tileWidth = {
  props: {
    tileWidth: {
      type: Number,
      default: 256
    }
  }
}

/**
 * @const {Number} tileHeight mixin
 */
const tileHeight = {
  props: {
    tileHeight: {
      type: Number,
      default: 256
    }
  }
}

/**
 * @const {Number} maximumLevel mixin
 */
const maximumLevel = {
  props: {
    maximumLevel: Number
  }
}

/**
 * @const {Number} minimumLevel mixin
 */
const minimumLevel = {
  props: {
    minimumLevel: {
      type: Number,
      default: 0
    }
  }
}

/**
 * @const {String} fileExtension mixin
 */
const fileExtension = {
  props: {
    fileExtension: {
      type: String,
      default: 'png'
    }
  }
}

/**
 * @const {String} accessToken mixin
 */
const accessToken = {
  props: {
    accessToken: String
  }
}

/**
 * @const {String} format mixin
 */
const format = {
  props: {
    format: {
      type: String,
      default: 'png'
    }
  }
}

/**
 * @const {String|Array} subdomains mixin
 */
const subdomains = {
  props: {
    subdomains: String | Array
  }
}

/**
 * @const {Array} getFeatureInfoFormats mixin
 */
const getFeatureInfoFormats = {
  props: {
    getFeatureInfoFormats: Array
  }
}

/**
 * @const {Object} clock mixin
 */
const clock = {
  props: {
    clock: Object
  }
}

/**
 * @const {Object} times mixin
 */
const times = {
  props: {
    times: Object
  }
}

// primitive 相关

/**
 * @const {Boolean}
 * allowPicking
 * asynchronous
 */
const aaMixin = {
  props: {
    allowPicking: {
      type: Boolean,
      default: true
    },
    asynchronous: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Boolean} debugShowShadowVolume mixin
 */
const debugShowShadowVolume = {
  props: {
    debugShowShadowVolume: {
      type: Boolean,
      default: false
    }
  }
}

/**
 * @const {Boolean} releaseGeometryInstances mixin
 */
const releaseGeometryInstances = {
  props: {
    releaseGeometryInstances: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Boolean} interleave mixin
 */
const interleave = {
  props: {
    interleave: {
      type: Boolean,
      default: false
    }
  }
}

/**
 * @const {Object} appearance mixin
 */
const appearance = {
  props: {
    appearance: Object
  }
}

/**
 * @const {Array|Object} geometryInstances mixin
 */
const geometryInstances = {
  props: {
    geometryInstances: Array | Object
  }
}

/**
 * @const {Boolean}
 * vertexCacheOptimize
 * compressVertices
 */
const vcMixin = {
  props: {
    vertexCacheOptimize: {
      type: Boolean,
      default: false
    },
    compressVertices: {
      type: Boolean,
      default: true
    }
  }
}

/**
 * @const {Object} modelMatrix mixin
 */
const modelMatrix = {
  props: {
    modelMatrix: Object
  }
}

/**
 * @const {Boolean} debugShowBoundingVolume mixin
 */
const debugShowBoundingVolume = {
  props: {
    debugShowBoundingVolume: {
      tyep: Boolean,
      default: false
    }
  }
}

/**
 * @const {Object} scene mixin
 */
const scene = {
  props: {
    scene: Object
  }
}

/**
 * @const {Number} blendOption mixin
 */
const blendOption = {
  props: {
    blendOption: {
      type: Number,
      default: 2
    }
  }
}

/**
 * @const {*} id mixin
 */
const id = {
  props: {
    id: null
  }
}

/**
 * @const {Boolean} loop mixin
 */
const loop = {
  props: {
    loop: {
      type: Boolean,
      default: false
    }
  }
}

/**
 * @const {Boolean} debugWireframe mixin
 */
const debugWireframe = {
  props: {
    debugWireframe: {
      type: Boolean,
      default: false
    }
  }
}

// geometry 相关

/**
 * @const {Object} vertexFormat mixin
 */
const vertexFormat = {
  props: {
    vertexFormat: Object
  }
}

/**
 * @const {Object} center mixin
 */
const center = {
  props: {
    center: Object
  }
}

/**
 * @const {Object} radius mixin
 */
const radius = {
  props: {
    radius: Number
  }
}
/**
 * @const {Object} innerRadii mixin
 */
const innerRadii = {
  props: {
    innerRadii: Object
  }
}
/**
 * @const {Object} minimumClock mixin
 */
const minimumClock = {
  props: {
    minimumClock: {
      type: Number,
      default: 0.0
    }
  }
}
/**
 * @const {Object} maximumClock mixin
 */
const maximumClock = {
  props: {
    maximumClock: {
      type: Number,
      default: 2 * Math.PI
    }
  }
}
/**
 * @const {Object} minimumCone mixin
 */
const minimumCone = {
  props: {
    minimumCone: {
      type: Number,
      default: 0.0
    }
  }
}
/**
 * @const {Object} maximumCone mixin
 */
const maximumCone = {
  props: {
    maximumCone: {
      type: Number,
      default: Math.PI
    }
  }
}

/**
 * @const {Object} frustum mixin
 */
const frustum = {
  props: {
    frustum: Object
  }
}

/**
 * @const {Object} origin mixin
 */
const origin = {
  props: {
    origin: Object
  }
}

/**
 * @const {Object} orientation mixin
 */
const orientation = {
  props: {
    orientation: Object
  }
}

/**
 * @const {Object} polygonHierarchy mixin
 */
const polygonHierarchy = {
  props: {
    polygonHierarchy: Object | Array
  }
}



// CONCATENATED MODULE: ./src/components/Base/Cesium/CesiumEvents.js
/**
 * @const {Array} Cesium 事件集合。
 */
const Events = {
  'vc-viewer': ['selectedEntityChanged', 'trackedEntityChanged'],
  'viewer-property-events': [
    {
      // viewer.imageryLayers
      name: 'imageryLayers',
      events: ['layerAdded', 'layerMoved', 'layerRemoved', 'layerShownOrHidden']
    },
    {
      // viewer.dataSources
      name: 'dataSources',
      events: ['dataSourceAdded', 'dataSourceMoved', 'dataSourceRemoved']
    },
    {
      // viewer.entities
      name: 'entities',
      events: ['collectionChanged']
    },
    {
      // viewer.scene
      name: 'scene',
      events: [
        'morphComplete',
        'morphStart',
        'postRender',
        'postUpdate',
        'preRender',
        'preUpdate',
        'renderError',
        'terrainProviderChanged'
      ]
    },
    {
      // viewer.camera
      name: 'camera',
      events: ['changed', 'moveEnd', 'moveStart']
    },
    {
      // viewer.clock
      name: 'clock',
      events: ['onStop', 'onTick']
    },
    {
      // viewer.terrainProvider
      name: 'terrainProvider',
      events: ['errorEvent']
    }
  ],
  'viewer-mouse-events': [
    'LEFT_CLICK',
    'LEFT_DOUBLE_CLICK',
    'LEFT_DOWN',
    'LEFT_UP',
    'MIDDLE_CLICK',
    'MIDDLE_DOWN',
    'MIDDLE_UP',
    'MOUSE_MOVE',
    'PINCH_END',
    'PINCH_MOVE',
    'PINCH_START',
    'RIGHT_CLICK',
    'RIGHT_DOWN',
    'RIGHT_UP',
    'WHEEL'
  ],
  'vc-primitive-3dtileset': [
    'allTilesLoaded',
    'initialTilesLoaded',
    'loadProgress',
    'tileFailed',
    'tileLoad',
    'tileUnload',
    'tileVisible'
  ],
  'imagery-layer-events': ['errorEvent'],
  'entity-events': ['definitionChanged'],
  'datasource-events': ['changedEvent', 'errorEvent', 'loadingEvent'],
  'datasource-property-events': [
    {
      name: 'clock',
      events: ['definitionChanged']
    },
    {
      name: 'clustering',
      events: ['clusterEvent']
    },
    {
      name: 'entities',
      events: ['collectionChanged']
    }
  ]
}

// CONCATENATED MODULE: ./src/components/Utils/log.js
/**
 * 输出正常信息到控制台。
 * @param  {...any} args
 */
function log (...args) {
  console.log('[VUE_CESIUM]', ...args)
}
/**
 * 输出警告信息到控制台。
 * @param {*} msg
 * @param  {...any} args
 */
function warn (msg, ...args) {
  console.warn(`[VUE_CESIUM] WARNING: ${msg}`, ...args)
}
/**
 * 输出错误信息到控制台。
 * @param {*} msg
 * @param  {...any} args
 */
function error (msg, ...args) {
  console.error(`[VUE_CESIUM] ERROR: ${msg}`, ...args)
}

// CONCATENATED MODULE: ./src/components/Base/Cesium/CesiumBindEvent.js




/**
 * 将 Cesium 对象事件注册为 Vue 组件事件。
 * @param {Object} instance Cesium 对象。
 * @param {Array} eventList 该 Cesium 的事件数组。
 * @param {Boolean} flag true 注册事件，false 注销事件。
 */
/* harmony default export */ var CesiumBindEvent = (function (instance, eventList, flag = true) {
  const ev = eventList || Events[toKebabCase(this.$options.name)]
  ev && ev.forEach(eventName => {
    if (instance[eventName]) {
      const listener = this.$listeners[eventName]
      const methodName = flag ? 'addEventListener' : 'removeEventListener'
      listener && instance[eventName][methodName](listener.fns)
    } else if (Object({"NODE_ENV":"production","BASE_URL":"/"}).VUECESIUM_DEBUG) {
      warn('Add event linstener of ' + eventName + ' failed, try to upgrade Cesium to latest version.')
    }
  })
});

// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/BaseProvider.js




const BaseProvider_methods = {
  async mount () {
    const { imageryProvider, providerContainer } = this
    imageryProvider.readyPromise.then(() => {
      const listener = this.$listeners['readyPromise']
      listener && this.$emit('readyPromise', imageryProvider)
    }).otherwise(error => {
      throw new Cesium.DeveloperError(error)
    })
    CesiumBindEvent.call(this, imageryProvider, Events['imagery-layer-events'], true)
    return providerContainer && providerContainer.setProvider(imageryProvider)
  },
  async unmount () {
    const { imageryProvider, providerContainer } = this
    CesiumBindEvent.call(this, imageryProvider, Events['imagery-layer-events'], false)
    return providerContainer && providerContainer.setProvider(undefined)
  }
}
/* harmony default export */ var BaseProvider = ({
  mixins: [VueVirtualCmp],
  methods: BaseProvider_methods,
  stubVNode: {
    empty () {
      return this.$options.name
    }
  },
  created () {
    this.renderByParent = true
    Object.defineProperties(this, {
      imageryProvider: {
        enumerable: true,
        get: () => this.cesiumObject
      },
      providerContainer: {
        enumerable: true,
        get: () => this.$services && this.$services.providerContainer
      }
    })
  }
});

// CONCATENATED MODULE: ./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/Provider/ImageProvider/Mapbox/MapboxImageryProvider.vue?vue&type=script&lang=js&



/* harmony default export */ var MapboxImageryProvidervue_type_script_lang_js_ = ({
  name: 'vue-provider-imagery-mapbox',
  mixins: [
    accessToken,
    format,
    ellipsoid,
    minimumLevel,
    maximumLevel,
    rectangle,
    credit,
    BaseProvider
  ],
  props: {
    url: {
      type: String,
      default: 'https://api.mapbox.com/v4/'
    },
    mapId: String
  }
});

// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/Mapbox/MapboxImageryProvider.vue?vue&type=script&lang=js&
 /* harmony default export */ var Mapbox_MapboxImageryProvidervue_type_script_lang_js_ = (MapboxImageryProvidervue_type_script_lang_js_); 
// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/Mapbox/MapboxImageryProvider.vue
var MapboxImageryProvider_render, MapboxImageryProvider_staticRenderFns




/* normalize component */

var MapboxImageryProvider_component = normalizeComponent(
  Mapbox_MapboxImageryProvidervue_type_script_lang_js_,
  MapboxImageryProvider_render,
  MapboxImageryProvider_staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* harmony default export */ var MapboxImageryProvider = (MapboxImageryProvider_component.exports);
// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/Mapbox/index.js



function Mapbox_plugin (Vue, options = {}) {
  if (Mapbox_plugin.installed) {
    return
  }
  Mapbox_plugin.installed = true

  Vue.component(MapboxImageryProvider.name, MapboxImageryProvider)
}

/* harmony default export */ var Mapbox = (Mapbox_plugin);



// CONCATENATED MODULE: ./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/Provider/ImageProvider/Custom/CustomImageryProvider.vue?vue&type=script&lang=js&



/* harmony default export */ var CustomImageryProvidervue_type_script_lang_js_ = ({
  name: "vue-provider-imagery-urltemplate",
  mixins: [
    url,
    subdomains,
    credit,
    minimumLevel,
    maximumLevel,
    rectangle,
    tilingScheme,
    ellipsoid,
    tileWidth,
    tileHeight,
    getFeatureInfoFormats,
    enablePickFeatures,
    BaseProvider
  ],
  props: {
    pickFeaturesUrl: String | Object,
    urlSchemeZeroPadding: Object,
    hasAlphaChannel: {
      type: Boolean,
      default: true
    },
    customTags: Object
  }
});

// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/Custom/CustomImageryProvider.vue?vue&type=script&lang=js&
 /* harmony default export */ var Custom_CustomImageryProvidervue_type_script_lang_js_ = (CustomImageryProvidervue_type_script_lang_js_); 
// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/Custom/CustomImageryProvider.vue
var CustomImageryProvider_render, CustomImageryProvider_staticRenderFns




/* normalize component */

var CustomImageryProvider_component = normalizeComponent(
  Custom_CustomImageryProvidervue_type_script_lang_js_,
  CustomImageryProvider_render,
  CustomImageryProvider_staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* harmony default export */ var CustomImageryProvider = (CustomImageryProvider_component.exports);
// CONCATENATED MODULE: ./src/components/Provider/ImageProvider/Custom/index.js



function Custom_plugin (Vue, options = {}) {
  if (Custom_plugin.installed) {
    return
  }
  Custom_plugin.installed = true

  Vue.component(CustomImageryProvider.name, CustomImageryProvider)
}

/* harmony default export */ var Custom = (Custom_plugin);



// CONCATENATED MODULE: ./src/components/DataSource/BaseDatasource.js






const BaseDatasource_methods = {
  async mount () {
    const { dataSources, datasource } = this
    CesiumBindEvent.call(this, datasource, Events['datasource-events'], true)
    Events['datasource-property-events'].forEach((eventName) => {
      datasource[eventName.name] && CesiumBindEvent.call(this, datasource[eventName.name], eventName.events, true)
    })
    datasource.show = this.show
    return dataSources && dataSources.add(datasource)
  },
  async unmount () {
    const { dataSources, datasource } = this
    CesiumBindEvent.call(this, datasource, Events['datasource-events'], false)
    Events['datasource-property-events'].forEach((eventName) => {
      datasource[eventName.name] && CesiumBindEvent.call(this, datasource[eventName.name], eventName.events, false)
    })
    return dataSources && dataSources.remove(datasource)
  },
  getServices () {
    const vm = this
    return multiMergeDescriptors(VueVirtualCmp.methods.getServices.call(this), {
      get datasource () {
        return vm.datasource
      },
      get entities () {
        return vm.datasource.entities
      }
    })
  }
}
/* harmony default export */ var BaseDatasource = ({
  mixins: [VueVirtualCmp, show],
  methods: BaseDatasource_methods,
  stubVNode: {
    attrs () {
      return {
        class: this.$options.name
      }
    }
  },
  created () {
    Object.defineProperties(this, {
      datasource: {
        enumerable: true,
        get: () => this.cesiumObject
      },
      dataSources: {
        enumerable: true,
        get: () => this.$services && this.$services.dataSources
      }
    })
  }
});

// CONCATENATED MODULE: ./node_modules/cache-loader/dist/cjs.js??ref--0-0!./node_modules/vue-loader/lib??vue-loader-options!./src/components/DataSource/Geojson/GeoJsonDataSource.vue?vue&type=script&lang=js&


/* harmony default export */ var GeoJsonDataSourcevue_type_script_lang_js_ = ({
  name: 'vue-datasource-geojson',
  mixins: [BaseDatasource],
  props: {
    data: {
      type: String | Object,
      required: true
    },
    options: {
      type: Object,
      default: () => {
        return {
          markerSize: 48,
          strokeWidth: 2,
          clampToGround: false
        }
      }
    }
  },
  methods: {
    async createCesiumObject () {
      const { $props, transformProps } = this
      const options = transformProps($props)
      return new Cesium.GeoJsonDataSource.load(options.data, options.options)
    }
  }
});

// CONCATENATED MODULE: ./src/components/DataSource/Geojson/GeoJsonDataSource.vue?vue&type=script&lang=js&
 /* harmony default export */ var Geojson_GeoJsonDataSourcevue_type_script_lang_js_ = (GeoJsonDataSourcevue_type_script_lang_js_); 
// CONCATENATED MODULE: ./src/components/DataSource/Geojson/GeoJsonDataSource.vue
var GeoJsonDataSource_render, GeoJsonDataSource_staticRenderFns




/* normalize component */

var GeoJsonDataSource_component = normalizeComponent(
  Geojson_GeoJsonDataSourcevue_type_script_lang_js_,
  GeoJsonDataSource_render,
  GeoJsonDataSource_staticRenderFns,
  false,
  null,
  null,
  null
  
)

/* harmony default export */ var GeoJsonDataSource = (GeoJsonDataSource_component.exports);
// CONCATENATED MODULE: ./src/components/DataSource/Geojson/index.js


function Geojson_plugin (Vue, options = {}) {
  if (Geojson_plugin.installed) {
    return
  }
  Geojson_plugin.installed = true

  Vue.component(GeoJsonDataSource.name, GeoJsonDataSource)
}

/* harmony default export */ var Geojson = (Geojson_plugin);



// CONCATENATED MODULE: ./src/index.js

// 影像




// 地形
// import * as CesiumTerrainProvider from './components/terrain/cesium'
// 数据源


/**
 * @const {string} VueCesium version
 */
const VERSION = "C_PKG_VERSION";

const $vc = {
  VERSION
};

/**
 * Register all VueCesium components.
 * @param {Object} Vue
 * @param {Object} options
 */
function src_plugin(Vue, options = {}) {
  if (src_plugin.installed) {
    return;
  }
  src_plugin.installed = true;
  // 视图
  Vue.use(WebGlobe_namespaceObject, options);
  Vue.use(Viewer, options);
  // 影像
  Vue.use(ImageProvider_namespaceObject, options);
  Vue.use(Mapbox_namespaceObject, options);
  Vue.use(Custom_namespaceObject, options);
  
  Vue.use(Geojson_namespaceObject, options);
  Vue.prototype.$vc = $vc;
}

/* harmony default export */ var src_0 = (src_plugin);

const CesiumWebGlobe = WebGlobe_namespaceObject;
const CesiumImageryLayer = ImageProvider_namespaceObject;
const CesiumGeojsonDatasource = Geojson_namespaceObject;



// CONCATENATED MODULE: ./node_modules/@vue/cli-service/lib/commands/build/entry-lib.js


/* harmony default export */ var entry_lib = __webpack_exports__["default"] = (src_0);



/***/ })

/******/ });